package org.bouncycastle.graphics.rt;

import javax.vecmath.*;

public abstract class Bounded
    extends Renderable
    implements Partitionable
{
    protected BBox          bBox = new BBox();

    protected void setBBox(
        BBox    bBox)
    {
        this.bBox.set(bBox);
    }

    protected void setBBox(
        float   x1,
        float   y1,
        float   z1,
        float   x2,
        float   y2,
        float   z2)
    {
        this.bBox.set(x1, y1, z1, x2, y2, z2);
    }

    /**
     * return a reference to the current bounding box.
     */
    public BBox bBox()
    {
        return bBox;
    }

    /**
     * apply the given 4x4 transform to the object.
     */
    public void transform(
        Matrix4f   trans)
    {
        super.transform(trans);

        bBox = bBox.getTransformedBBox(trans);
    }

    public abstract boolean isIntersected(Ray r);

    public abstract boolean isShadowing(Ray r);
}
