package org.bouncycastle.graphics.rt;

public class HitIterator
{
    private static HitIterator dataList = null;

    private boolean             disposed = false;
    private HitIterator         next = null;

    Hit data;

    private HitIterator()
    {
    }
    
    public static HitIterator getInstance(
        Hit   data)
    {
        HitIterator   d;

        if (dataList == null)
        {
            d = new HitIterator();
        }
        else
        {
            d = dataList;
            dataList = dataList.next;
        }

        d.data = data;
        d.disposed = false;

        return d;
    }

    public void dispose()
    {
        if (this.disposed)
        {
            throw new IllegalStateException("attempt to free HitIterator already freed");
        }

        this.disposed = true;
        this.next = dataList;
        dataList = this;
    }

    public boolean hasNext()
    {
        return (data != null);
    }
    
    public Hit next()
    {
        Hit  ld = data;
    
        data = data.next;
    
        return ld;
    }
}
