package org.bouncycastle.graphics.rt;

import javax.vecmath.*;

public class LightData
{
    private static LightData    list = null;

    private float        nDotL;
    private Vector3f     dir = new Vector3f();
    private Color3f      col = new Color3f();

    LightData    next;

    public static LightData getInstance(
        float          nDotL,
        Vector3f       L,
        Color3f        col)
    {
        LightData    p;

        if (list == null)
        {
            p = new LightData();
        }
        else
        {
            p = list;
            list = list.next;
        }        

        p.nDotL = nDotL;
        p.dir.set(L);
        p.col.set(col);
        p.next = null;

        return p;
    }

    public void dispose()
    {
        this.next = list;
        list = this;
    }

    public float NDotL()
    {
        return nDotL;
    }

    public Vector3f L()
    {
        return dir;
    }

    public Color3f color()
    {
        return col;
    }
}
