package org.bouncycastle.graphics.rt;

public class LightDataIterator
{
    private static LightDataIterator dataList = null;

    private boolean             disposed = false;
    private LightDataIterator   next = null;

    LightData data;

    private LightDataIterator()
    {
    }
    
    public static LightDataIterator getInstance(
        LightData   data)
    {
        LightDataIterator   d;

        if (dataList == null)
        {
            d = new LightDataIterator();
        }
        else
        {
            d = dataList;
            dataList = dataList.next;
        }

        d.data = data;
        d.disposed = false;

        return d;
    }

    public void dispose()
    {
        if (this.disposed)
        {
            throw new IllegalStateException("attempt to free LightDataIterator already freed");
        }

        this.disposed = true;
        this.next = dataList;
        dataList = this;
    }

    public boolean hasNext()
    {
        return (data != null);
    }
    
    public LightData next()
    {
        LightData  ld = data;
    
        data = data.next;
    
        return ld;
    }
}
