package org.bouncycastle.graphics.rt;

import java.util.*;

public class LightDataList
{
    private LightData data;
    private LightData tail;

    private LightDataList   next = null;
    private boolean         disposed = false;

    static  LightDataList   dataList = null;

    private LightDataList()
    {
    }

    public static LightDataList getInstance()
    {
        LightDataList   l;

        if (dataList == null)
        {
            l = new LightDataList();
        }
        else
        {
            l = dataList;
            dataList = dataList.next;
        }

        l.disposed = false;
        l.data = null;
        l.tail = null;

        return l;
    }

    public void dispose()
    {
        if (this.disposed)
        {
            throw new IllegalStateException("attempt to free LightDataList already freed");
        }

        this.disposed = true;
        this.next = dataList;
        dataList = this;

        LightDataIterator it = this.iterator();

        while (it.hasNext())
        {
            it.next().dispose();
        }
    }

    public void add(
        LightData  newData)
    {
        if (tail == null)
        {
            data = tail = newData;
        }
        else
        {
            tail.next = newData;
        }
    }

    public LightDataIterator iterator()
    {
        return LightDataIterator.getInstance(data);
    }
}
