package org.bouncycastle.graphics.rt.mappers;

import javax.vecmath.*;

import org.bouncycastle.graphics.rt.*;

public class CylindricalMap
    implements TextureMapper
{
    public static TextureMapper canonicalMap = new CylindricalMap();

    /*
     * generate a planar mapping from a surface onto a tile. In this case
     * we calculate for a cylinder running along the z axis.
     */
    public boolean getST(
        Tuple3f    l,
        float[]    uv)
    {
        Vector3f    tmp = new Vector3f();
        int        w, h, indx;

        tmp.x = l.x;
        tmp.y = l.y;
        tmp.z = 0;

        tmp.normalize();

        tmp.z = l.z;

        if (Math.abs(tmp.x) > 1)
        {
            tmp.x = (tmp.x < 0) ? -1 : 1;
        }

        uv[T] = Math.abs(tmp.z);

        if (tmp.y < 0)
        {
            uv[S] = 1 - (float)(Math.acos(tmp.x) / (2.0 * Math.PI));
        }
        else
        {
            uv[S] = (float)(Math.acos(tmp.x) / (2.0 * Math.PI));
        }

        return true;
    }
}
