package org.bouncycastle.graphics.rt.mappers;

import javax.vecmath.*;

import org.bouncycastle.graphics.rt.*;

public class DiskMap
    implements TextureMapper
{
    public boolean getST(
        Tuple3f    l,
        float[]    uv)
    {
        int    w, h, indx;

        uv[T] = 1 - (float)Math.sqrt((l.x * l.x) + (l.y * l.y));

        if (l.x != 0 && l.y != 0)
        {
            l.scale((float)Math.sqrt(
                    (l.x * l.x) + (l.y * l.y) + l.z * l.z));
        }

        if (Math.abs(l.x) > 1)
        {
            l.x = (l.x < 0) ? -1 : 1;
        }
        
        if (l.y < 0)
        {
            uv[S] = 1 - (float)(Math.acos(l.x) / (2 * Math.PI));
        }
        else
        {
            uv[S] = (float)(Math.acos(l.x) / (2 * Math.PI));
        }

        return true;
    }
}
