package org.bouncycastle.graphics.rt.objects;

import java.io.*;
import java.util.*;

import javax.vecmath.*;

import org.bouncycastle.graphics.rt.tools.io.*;

public class XGeometry
{
    Matrix4f    geometry = new Matrix4f();

    public static XGeometry getInstance(
        RMLReader   in)
        throws IOException
    {
        XGeometry   g = new XGeometry();

        if (in.readNext() != RMLReader.EOF)
        {
            StringTokenizer st = new StringTokenizer(in.toString(), ", \t");
    
            if (st.countTokens() == 16)
            {
                for (int i = 0; i != 4; i++)
                {
                    for (int j = 0; j != 4; j++)
                    {
                        g.geometry.setElement(i, j,
                                    Float.parseFloat(st.nextToken()));
                    }
                }
            }
            else
            {
                throw new IOException("badly formatted geometry tag");
            }
        }
        else
        {
            throw new IOException("unexpected EOF in geometry tag");
        }

        //
        // swallow the end tag.
        //
        if (in.readNext() == RMLReader.EOF)
        {
            throw new IOException("unexpected EOF in geometry tag");
        }

        return g;
    }

    public Matrix4f geometry()
    {
        return geometry;
    }
}
