package org.bouncycastle.graphics.rt.util;

import java.util.*;

import javax.vecmath.*;

public class ParametersMap
    extends HashMap
{
    public Point3f getPoint(
        String  name,
        String  def)
    {
        StringTokenizer tok;

        if (this.get(name) != null)
        {
            tok = new StringTokenizer((String)this.get(name), " ,");
        }
        else
        {
            tok = new StringTokenizer(def, " ,");
        }

        Point3f p = new Point3f();

        p.x = Float.parseFloat(tok.nextToken());
        p.y = Float.parseFloat(tok.nextToken());
        p.z = Float.parseFloat(tok.nextToken());

        return p;
    }   

    public Vector3f getVector(
        String  name,
        String  def)
    {
        StringTokenizer tok;

        if (this.get(name) != null)
        {
            tok = new StringTokenizer((String)this.get(name), " ,");
        }
        else
        {
            tok = new StringTokenizer(def, " ,");
        }

        Vector3f v = new Vector3f();

        v.x = Float.parseFloat(tok.nextToken());
        v.y = Float.parseFloat(tok.nextToken());
        v.z = Float.parseFloat(tok.nextToken());

        return v;
    }   

    public Color3f getColor(
        String  name,
        String  def)
    {
        StringTokenizer tok;

        if (this.get(name) != null)
        {
            tok = new StringTokenizer((String)this.get(name), " ,");
        }
        else
        {
            tok = new StringTokenizer(def, " ,");
        }

        Color3f c = new Color3f();

        c.x = Float.parseFloat(tok.nextToken());
        if (tok.hasMoreTokens())
        {
            c.y = Float.parseFloat(tok.nextToken());
            c.z = Float.parseFloat(tok.nextToken());
        }
        else
        {
            c.y = c.z = c.x;
        }

        return c;
    }

    public float getFloat(
        String  name,
        String  def)
    {
        if (this.get(name) != null)
        {
            return Float.parseFloat((String)this.get(name));
        }

        return Float.parseFloat(def);
    }

    public int getInt(
        String  name,
        String  def)
    {
        if (this.get(name) != null)
        {
            return Integer.parseInt((String)this.get(name));
        }

        return Integer.parseInt(def);
    }

    public boolean getBoolean(
        String  name,
        String  def)
    {
        if (this.get(name) != null)
        {
            return Boolean.valueOf((String)this.get(name)).booleanValue();
        }

        return Boolean.valueOf(def).booleanValue();
    }

    public String getString(
        String  name,
        String  def)
    {
        if (this.get(name) != null)
        {
            return (String)this.get(name);
        }

        return def;
    }
}
